package model;

import java.util.ArrayList;

public class Calculator<Item> {
	private final Operation<Item> operation;

	public Calculator(Operation<Item> operation) {
		this.operation = operation;
	}
	
	public void Calculate(Item[] input) {
            ArrayList<CalculatorThread<Item>> calcs = new ArrayList<>();
            ArrayList<Thread> calcthreads = new ArrayList<>();

            for (int i = 0; i < input.length; i++) {
                calcs.add(new CalculatorThread<Item>(calcs, operation, i, input[i]));
                calcthreads.add(new Thread(calcs.get(i)));
                calcthreads.get(i).start();
            }

            for (int i = 0; i < input.length; i++) {
                try {
                       calcthreads.get(i).join();
                } catch (InterruptedException e) {}
            }
	}
}
